<?xml version="1.0" encoding="UTF-8" ?>
<!DOCTYPE mapper
PUBLIC "-//mybatis.org//DTD Mapper 3.0//EN"
"http://mybatis.org/dtd/mybatis-3-mapper.dtd">
<mapper namespace="com.ruoyi.kaohe.mapper.KhItemsMapper">
    
    <resultMap type="KhItems" id="KhItemsResult">
        <result property="id"    column="id"    />
        <result property="itemName"    column="item_name"    />
        <result property="typeId"    column="type_id"    />
        <result property="type"    column="type"    />
        <result property="createBy"    column="create_by"    />
        <result property="createTime"    column="create_time"    />
        <result property="updateBy"    column="update_by"    />
        <result property="updateTime"    column="update_time"    />
        <result property="remark"    column="remark"    />
    </resultMap>

    <sql id="selectKhItemsVo">
        select id, item_name, type_id, type, create_by, create_time, update_by, update_time, remark from kh_items
    </sql>

    <select id="selectKhItemsList" parameterType="KhItems" resultMap="KhItemsResult">
        <include refid="selectKhItemsVo"/>
        <where>  
            <if test="itemName != null  and itemName != ''"> and item_name like concat('%', #{itemName}, '%')</if>
            <if test="typeId != null "> and type_id = #{typeId}</if>
            <if test="type != null  and type != ''"> and type = #{type}</if>
        </where>
    </select>
    
    <select id="selectKhItemsById" parameterType="Long" resultMap="KhItemsResult">
        <include refid="selectKhItemsVo"/>
        where id = #{id}
    </select>

    <insert id="insertKhItems" parameterType="KhItems" useGeneratedKeys="true" keyProperty="id">
        insert into kh_items
        <trim prefix="(" suffix=")" suffixOverrides=",">
            <if test="itemName != null and itemName != ''">item_name,</if>
            <if test="typeId != null">type_id,</if>
            <if test="type != null">type,</if>
            <if test="createBy != null">create_by,</if>
            <if test="createTime != null">create_time,</if>
            <if test="updateBy != null">update_by,</if>
            <if test="updateTime != null">update_time,</if>
            <if test="remark != null">remark,</if>
         </trim>
        <trim prefix="values (" suffix=")" suffixOverrides=",">
            <if test="itemName != null and itemName != ''">#{itemName},</if>
            <if test="typeId != null">#{typeId},</if>
            <if test="type != null">#{type},</if>
            <if test="createBy != null">#{createBy},</if>
            <if test="createTime != null">#{createTime},</if>
            <if test="updateBy != null">#{updateBy},</if>
            <if test="updateTime != null">#{updateTime},</if>
            <if test="remark != null">#{remark},</if>
         </trim>
    </insert>

    <update id="updateKhItems" parameterType="KhItems">
        update kh_items
        <trim prefix="SET" suffixOverrides=",">
            <if test="itemName != null and itemName != ''">item_name = #{itemName},</if>
            <if test="typeId != null">type_id = #{typeId},</if>
            <if test="type != null">type = #{type},</if>
            <if test="createBy != null">create_by = #{createBy},</if>
            <if test="createTime != null">create_time = #{createTime},</if>
            <if test="updateBy != null">update_by = #{updateBy},</if>
            <if test="updateTime != null">update_time = #{updateTime},</if>
            <if test="remark != null">remark = #{remark},</if>
        </trim>
        where id = #{id}
    </update>

    <delete id="deleteKhItemsById" parameterType="Long">
        delete from kh_items where id = #{id}
    </delete>

    <delete id="deleteKhItemsByIds" parameterType="String">
        delete from kh_items where id in 
        <foreach item="id" collection="array" open="(" separator="," close=")">
            #{id}
        </foreach>
    </delete>
</mapper>